﻿Public Class AccountRecForm

    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM = Nothing
    Private Shared m_objAccountRecForm As AccountRecForm = Nothing
    Private m_bBtnAdvanceShow As Boolean = True

    Public Sub New()

        m_objAccountRecForm = Me
        InitializeComponent()

        m_objVaxUserAgent = cVaxSIPUserAgentExCOM.GetOBJ()
        LoadAccountData()

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Shared Function GetOBJ() As AccountRecForm
        Return m_objAccountRecForm
    End Function

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnOnline_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        If BtnOnline.Content.ToString() = "Offline" Then

            m_objVaxUserAgent.UnRegisterAccountREC()
            BtnOnline.Content = "Online"

            Return

        End If

        If EditAuthLogin.Text = "" Then
            MessageBox.Show("Invalid auth Login.", "VaxVoIP SDK", MessageBoxButton.OK, MessageBoxImage.Exclamation)
            Return
        End If

        If EditServerAddr.Text = "" Then
            MessageBox.Show("Invalid SIP server domain or IP address.", "VaxVoIP SDK", MessageBoxButton.OK, MessageBoxImage.Exclamation)
            Return
        End If

        cStoreAccountREC.AddAccountInfo(EditDisplayName.Text, EditUserName.Text, EditAuthLogin.Text, EditAuthPwd.Text, EditDomainRealm.Text, EditServerAddr.Text, Convert.ToInt32(EditServerPort.Text), CheckRegisterToServerREC.IsChecked.Value)

        If Not m_objVaxUserAgent.RegisterAccountREC(CheckRegisterToServerREC.IsChecked.Value, EditDisplayName.Text, EditUserName.Text, EditAuthLogin.Text, EditAuthPwd.Text, EditDomainRealm.Text, EditServerAddr.Text, Convert.ToInt32(EditServerPort.Text)) Then
            Return
        End If

        If CheckRegisterToServerREC.IsChecked Then
            AddToStatusLog("Registering to SIP Server REC")
        End If

        BtnOnline.Content = "Offline"

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnAdvance_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        If m_bBtnAdvanceShow Then

            LabelDisplayName.Visibility = Visibility.Visible
            LabelUserName.Visibility = Visibility.Visible

            LabelDomain.Visibility = Visibility.Visible
            EditDisplayName.Visibility = Visibility.Visible

            EditUserName.Visibility = Visibility.Visible
            EditDomainRealm.Visibility = Visibility.Visible

            BtnAdvance.Content = "Basic"
            m_bBtnAdvanceShow = False

            Return
        End If

        LabelDisplayName.Visibility = Visibility.Hidden
        LabelUserName.Visibility = Visibility.Hidden

        LabelDomain.Visibility = Visibility.Hidden
        EditDisplayName.Visibility = Visibility.Hidden

        EditUserName.Visibility = Visibility.Hidden
        EditDomainRealm.Visibility = Visibility.Hidden

        BtnAdvance.Content = "Advance"
        m_bBtnAdvanceShow = True

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnClearStatusLog_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ListBoxStatusLog.Items.Clear()
    End Sub

    Private Sub BtnClearCallLog_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ListBoxCallLog.Items.Clear()
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AddToStatusLog(ByVal sStatus As String)
        ListBoxStatusLog.Items.Add(sStatus)
    End Sub

    Private Sub AddToCallLog(ByVal sStatus As String)
        ListBoxCallLog.Items.Add(sStatus)
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub LoadAccountData()

        Dim sDisplayName As String = ""
        Dim sUserName As String = ""

        Dim sAuthLogin As String = ""
        Dim sAuthPwd As String = ""

        Dim sDomainRealm As String = ""
        Dim sServerAddr As String = ""

        Dim nServerPort As Integer = 5060
        Dim bRegisterREC As Boolean = True

        cStoreAccountREC.GetAccountInfo(sDisplayName, sUserName, sAuthLogin, sAuthPwd, sDomainRealm, sServerAddr, nServerPort, bRegisterREC)

        EditDisplayName.Text = sDisplayName
        EditUserName.Text = sUserName

        EditAuthLogin.Text = sAuthLogin
        EditAuthPwd.Text = sAuthPwd

        EditDomainRealm.Text = sDomainRealm
        EditServerAddr.Text = sServerAddr
        EditServerPort.Text = Convert.ToString(nServerPort)

        CheckRegisterToServerREC.IsChecked = bRegisterREC

    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnConnectingToRegister()
        AddToStatusLog("Connecting to register.")
    End Sub

    Public Sub OnTryingToRegister()
        AddToStatusLog("Trying to register.")
    End Sub

    Public Sub OnFailToRegister(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToStatusLog("Failed: " & sReasonPhrase)
    End Sub

    Public Sub OnSuccessToRegister()
        AddToStatusLog("Success to register.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnTryingToReRegister()
        AddToStatusLog("Trying to Re-Register.")
    End Sub

    Public Sub OnFailToReRegister(ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToStatusLog("Failed: " & sReasonPhrase)
    End Sub

    Public Sub OnSuccessToReRegister()
        AddToStatusLog("Success to Re-Register.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnTryingToUnRegister()
        AddToStatusLog("Trying to Unregister.")
    End Sub

    Public Sub OnFailToUnRegister()
        AddToStatusLog("Fail to unregister.")
    End Sub

    Public Sub OnSuccessToUnRegister()
        AddToStatusLog("Unregistered successfully.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnDialCallStarted(ByVal nLineNo As Integer, ByVal sCallerName As String, ByVal sCallerId As String, ByVal sDialNo As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Dialing.")
    End Sub

    Public Sub OnDialingCall(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Response: " & sReasonPhrase)
    End Sub

    Public Sub OnConnectedCall(ByVal nLineNo As Integer)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Success to connect.")
    End Sub

    Public Sub OnDialCallFailed(ByVal nLineNo As Integer, ByVal nStatusCode As Integer, ByVal sReasonPhrase As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Response: " & sReasonPhrase)
    End Sub

    Public Sub OnHungupCall(ByVal nLineNo As Integer)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": Hang up.")
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnStatusMsg(ByVal nLineNo As Integer, ByVal nErrorCode As Integer, ByVal sErrorMsg As String)
        AddToCallLog("Line-" & Convert.ToString(nLineNo + 1) & ": " & sErrorMsg)
    End Sub

    '/////////////////////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ScrollViewer_OnListBoxScrollChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.ScrollChangedEventArgs)

        If TypeOf e.OriginalSource Is ScrollViewer AndAlso Math.Abs(e.ExtentHeightChange) > 0.0 Then
            Dim hScroll As ScrollViewer = CType(e.OriginalSource, ScrollViewer)
            hScroll.ScrollToBottom()
        End If

    End Sub

End Class
