﻿Partial Public Class PhoneForm

    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM = Nothing
    Private Shared m_objPhoneForm As PhoneForm = Nothing

    Public Sub New()
        m_objPhoneForm = Me
        m_objVaxUserAgent = cVaxSIPUserAgentExCOM.GetOBJ()
        InitializeComponent()
    End Sub

    Public Shared Function GetOBJ() As PhoneForm
        Return m_objPhoneForm
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOnline()

        LoadPhoneNo()

        ComboDialCallSecureMediaSRTP.Items.Clear()
        ComboDialCallSecureMediaSRTP.Items.Add("Secure Media None")
        ComboDialCallSecureMediaSRTP.Items.Add("Secure Media Forced")
        ComboDialCallSecureMediaSRTP.SelectedIndex = 0

        ComboAcceptCallSecureMediaSRTP.Items.Clear()
        ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media Auto")
        ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media None")
        ComboAcceptCallSecureMediaSRTP.Items.Add("Secure Media Forced")
        ComboAcceptCallSecureMediaSRTP.SelectedIndex = 0

        ComboVoiceChanger.Items.Clear()
        ComboVoiceChanger.Items.Add("Disable")
        ComboVoiceChanger.Items.Add("Grandpa drunk")
        ComboVoiceChanger.Items.Add("Teen boy")
        ComboVoiceChanger.Items.Add("Household robot")
        ComboVoiceChanger.Items.Add("Helium inhaled")
        ComboVoiceChanger.Items.Add("Chipmunk")
        ComboVoiceChanger.SelectedIndex = 0

        OnVaxForwardCallOnline()
        OnVaxVoiceOnline()

        OnVaxLineOnline()
        OnVaxToneOnline()

    End Sub

    Public Sub OnVaxOffline()

        ListBoxStatusLog.Items.Clear()
        OnVaxIncomingCallOffline()

        OnVaxVoiceOffline()
        OnVaxLineOffline()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AddToStatusLog(ByVal sStatusLog As String)
        ListBoxStatusLog.Items.Add(sStatusLog)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnClearLog_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ListBoxStatusLog.Items.Clear()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnDigitDTMF(ByVal nLineNo As Integer, ByVal sDigit As String)
        AddToStatusLog("Line-" & Convert.ToString(nLineNo + 1) & ": Key-pressed: " + sDigit)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnDetectedAMD(ByVal nLineNo As Integer, ByVal bIsHuman As Boolean)

        If Not bIsHuman Then
            AddToStatusLog("Line-" & Convert.ToString(nLineNo + 1) & ": Answering Machine [Yes]")
        Else
            AddToStatusLog("Line-" & Convert.ToString(nLineNo + 1) & ": Answering Machine [No]")
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnNetworkReachability(ByVal bAvailable As Boolean)

        If bAvailable Then
            AddToStatusLog("Network is available")
        Else
            AddToStatusLog("Network is not available")
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub LoadPhoneNo()

        Dim sPhoneNo As String = ""
        cStorePhoneNo.GetPhoneNo(sPhoneNo)

        EditPhoneNo.Text = sPhoneNo

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub AdjustSecureMediaSRTP(ByVal bDialCall As Boolean)

        Dim nSecureIndex As Integer = -1

        If bDialCall Then
            nSecureIndex = ComboDialCallSecureMediaSRTP.SelectedIndex

            If nSecureIndex = -1 OrElse nSecureIndex = 0 Then
                m_objVaxUserAgent.CryptoMediaNONE(False)
                Return
            End If

            If nSecureIndex = 1 Then
                m_objVaxUserAgent.CryptoMediaSDP(True)
                Return
            End If

            Return
        End If

        nSecureIndex = ComboAcceptCallSecureMediaSRTP.SelectedIndex

        If nSecureIndex = -1 OrElse nSecureIndex = 0 Then
            m_objVaxUserAgent.CryptoMediaNONE(False)
            Return
        End If

        If nSecureIndex = 1 Then
            m_objVaxUserAgent.CryptoMediaNONE(True)
            Return
        End If

        If nSecureIndex = 2 Then
            m_objVaxUserAgent.CryptoMediaSDP(True)
            Return
        End If

    End Sub
    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub UpdateBtnStatus()

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        If Not m_objVaxUserAgent.IsLineRecording(nLineNo) AndAlso BtnStartRecording.Content <> "Start" Then
            BtnStartRecording.Content = "Start"
        ElseIf m_objVaxUserAgent.IsLineRecording(nLineNo) AndAlso BtnStartRecording.Content <> "Stop" Then
            BtnStartRecording.Content = "Stop"
        End If

        If Not m_objVaxUserAgent.IsLineBusy(nLineNo) AndAlso BtnDial.Content <> "Dial" Then
            BtnDial.Content = "Dial"
        ElseIf m_objVaxUserAgent.IsLineBusy(nLineNo) AndAlso BtnDial.Content <> "Hangup" Then
            BtnDial.Content = "Hangup"
        End If

        If Not m_objVaxUserAgent.IsLineHold(nLineNo) AndAlso BtnHold.Content <> "Hold" Then
            BtnHold.Content = "Hold"
        ElseIf m_objVaxUserAgent.IsLineHold(nLineNo) AndAlso BtnHold.Content <> "UnHold" Then
            BtnHold.Content = "UnHold"
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckDetectAMD_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        m_objVaxUserAgent.DetectAMD(CheckDetectAMD.IsChecked.Value)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ComboVoiceChanger_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)

        Dim nVoiceChangerType As Integer = ComboVoiceChanger.SelectedIndex
        If nVoiceChangerType = -1 Then Return

        Select Case nVoiceChangerType

            Case 0
                m_objVaxUserAgent.VoiceChanger(-1)
            Case 1
                m_objVaxUserAgent.VoiceChanger(4)
            Case 2
                m_objVaxUserAgent.VoiceChanger(8)
            Case 3
                m_objVaxUserAgent.VoiceChanger(12)
            Case 4
                m_objVaxUserAgent.VoiceChanger(16)
            Case 5
                m_objVaxUserAgent.VoiceChanger(20)

        End Select

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckDisturb_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        m_objVaxUserAgent.DonotDisturb(CheckDisturb.IsChecked.Value)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ScrollViewer_OnListBoxScrollChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.ScrollChangedEventArgs)

        If TypeOf e.OriginalSource Is ScrollViewer AndAlso Math.Abs(e.ExtentHeightChange) > 0.0 Then
            Dim hScroll As ScrollViewer = CType(e.OriginalSource, ScrollViewer)
            hScroll.ScrollToBottom()
        End If

    End Sub

End Class
