﻿
Partial Public Class PhoneForm

    Private m_objAlertForm As PhoneIncomingCallForm = Nothing
    Private Const PHONE_TAB_PAGE_INDEX As Integer = 1

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxIncomingCallOffline()
        ListBoxIncomingCall.Items.Clear()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Function GenCallerInfo(ByVal sCallerName As String, ByVal sCallerId As String) As String

        Dim sCallerInfo As String

        If sCallerName.Length <> 0 Then
            sCallerInfo = String.Format("NAME: {0}, CLI: {1}", sCallerName, sCallerId)
        Else
            sCallerInfo = String.Format("NAME: Unknown, CLI: {0}", sCallerId)
        End If

        Return sCallerInfo

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnIncomingCallStarted(ByVal sCallId As String, ByVal sCallerName As String, ByVal sCallerId As String)

        Dim bResult As Boolean = FindCallId(sCallId)
        If bResult Then Return

        Dim sCallerInfo As String = GenCallerInfo(sCallerName, sCallerId)
        ListBoxIncomingCall.Items.Add(New cListIncomingCall(sCallId, sCallerInfo))

        If (ListBoxIncomingCall.SelectedIndex = -1) AndAlso (ListBoxIncomingCall.Items.Count > 0) Then
            ListBoxIncomingCall.SelectedIndex = 0
        End If

        ShowIncomingCallMsgBox(True)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnIncomingCallEnded(ByVal sCallId As String)
        ShowIncomingCallMsgBox(False)
        RemoveCallIdFromList(sCallId)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ShowIncomingCallMsgBox(ByVal bShow As Boolean)

        If bShow Then

            Dim nTabIndex As Integer = MainForm.m_objMainForm.GetActiveTab()

            If nTabIndex = PHONE_TAB_PAGE_INDEX OrElse m_objAlertForm IsNot Nothing Then
                Return
            End If

            m_objAlertForm = New PhoneIncomingCallForm(Me)
            m_objAlertForm.ShowDialog()

            Return

        End If

        If m_objAlertForm Is Nothing Then
            Return
        End If

        m_objAlertForm.Close()
        m_objAlertForm = Nothing

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnAccept_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        Dim nSelectedItemIndex As Integer = ListBoxIncomingCall.SelectedIndex
        If nSelectedItemIndex = -1 Then Return

        Dim objListIncomingCall As cListIncomingCall = CType(ListBoxIncomingCall.Items(nSelectedItemIndex), cListIncomingCall)

        Dim sCallId As String = objListIncomingCall.m_sCallId
        Dim nLineNo As Integer = FindLine()

        If nLineNo = -1 Then
            MessageBox.Show("No line is free")
            Return
        End If

        AdjustSecureMediaSRTP(False)

        Dim bResult As Boolean = m_objVaxUserAgent.AcceptCall(nLineNo, sCallId)
        If Not bResult Then Return

        ListBoxIncomingCall.Items.Remove(objListIncomingCall)
        ShowListBoxLineStatus(nLineNo, "CONNECTING")

        If ListBoxIncomingCall.Items.Count > 0 Then
            If ListBoxIncomingCall.SelectedIndex = -1 Then ListBoxIncomingCall.SelectedIndex = 0
            Return
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub BtnReject_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        Dim nSelectedItemIndex As Integer = ListBoxIncomingCall.SelectedIndex
        If nSelectedItemIndex = -1 Then Return

        Dim objListIncomingCall As cListIncomingCall = CType(ListBoxIncomingCall.Items(nSelectedItemIndex), cListIncomingCall)

        Dim sCallId As String = objListIncomingCall.m_sCallId

        Dim bResult As Boolean = m_objVaxUserAgent.RejectCall(sCallId)
        If Not bResult Then Return

        ListBoxIncomingCall.Items.Remove(objListIncomingCall)

        If ListBoxIncomingCall.Items.Count > 0 Then
            If ListBoxIncomingCall.SelectedIndex = -1 Then ListBoxIncomingCall.SelectedIndex = 0
            Return
        End If

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Function FindCallId(ByVal sCallId As String) As Boolean

        Dim objListIncomingCall As cListIncomingCall

        For nListIndex As Integer = 0 To ListBoxIncomingCall.Items.Count - 1
            objListIncomingCall = CType(ListBoxIncomingCall.Items(nListIndex), cListIncomingCall)
            If sCallId = objListIncomingCall.m_sCallId Then Return True
        Next

        Return False

    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub RemoveCallIdFromList(ByVal sCallId As String)

        Dim objListIncomingCall As cListIncomingCall

        For nListIndex As Integer = 0 To ListBoxIncomingCall.Items.Count - 1
            objListIncomingCall = CType(ListBoxIncomingCall.Items(nListIndex), cListIncomingCall)

            If sCallId = objListIncomingCall.m_sCallId Then
                ListBoxIncomingCall.Items.Remove(objListIncomingCall)
                objListIncomingCall = Nothing
                Return
            End If
        Next

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OkAlert()
        MainForm.m_objMainForm.SetActiveTab(PHONE_TAB_PAGE_INDEX)
        m_objAlertForm.Close()
        m_objAlertForm = Nothing
    End Sub

    Public Sub CancelAlert()
        m_objAlertForm.Close()
        m_objAlertForm = Nothing
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

End Class

'////////////////////////////////////////////////////////////////////////////////
'///////////////////////////////////////////////////////////////////////////////

Class cListIncomingCall

    Public m_sCallId As String
    Public m_sCallerInfo As String

    Public Sub New(ByVal sCallId As String, ByVal sCallerInfo As String)
        m_sCallId = sCallId
        m_sCallerInfo = sCallerInfo
    End Sub

    Public Overrides Function ToString() As String
        Return m_sCallerInfo
    End Function

End Class
