﻿Partial Public Class PhoneForm

    Private m_aLineVoice As cLineVoice()

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxVoiceOnline()

        Dim nTotalLine As Integer = m_objVaxUserAgent.GetTotalLine()
        m_aLineVoice = New cLineVoice(nTotalLine - 1) {}

        For nLineNo As Integer = 0 To nTotalLine - 1
            m_aLineVoice(nLineNo) = New cLineVoice()
        Next

        CheckLeftSpkListen.IsChecked = True
        CheckRightSpkListen.IsChecked = True

        CheckAllowListenConf.IsChecked = True
        CheckAllowSpeakConf.IsChecked = True

        CheckMuteLineSPK.IsChecked = False
        CheckMuteLineMIC.IsChecked = False

        SliderSpkVol.Value = 100
        SliderMicVol.Value = 10

        m_objVaxUserAgent.AudioDeviceVU(True, True, True)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxVoiceOffline()
        SpkProgBar.Value = 0
        MicProgBar.Value = 0
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckMuteLineSPK_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.MuteLineSpk(nLineNo, CheckMuteLineSPK.IsChecked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bMuteLineSPK = CheckMuteLineSPK.IsChecked

    End Sub

    Private Sub CheckMuteLineMIC_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.MuteLineMic(nLineNo, CheckMuteLineMIC.IsChecked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bMuteLineMIC = CheckMuteLineMIC.IsChecked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckLeftSpkListen_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        If CheckLeftSpkListen.IsChecked = False AndAlso CheckRightSpkListen.IsChecked = False Then
            CheckRightSpkListen.IsChecked = True
        End If

        Dim bResult As Boolean = m_objVaxUserAgent.LineVoiceChannelSpk(nLineNo, SpkListenChannel(CheckLeftSpkListen.IsChecked, CheckRightSpkListen.IsChecked))
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bListenLeftSpk = CheckLeftSpkListen.IsChecked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckRightSpkListen_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        If CheckLeftSpkListen.IsChecked = False AndAlso CheckRightSpkListen.IsChecked = False Then
            CheckLeftSpkListen.IsChecked = True
        End If

        Dim bResult As Boolean = m_objVaxUserAgent.LineVoiceChannelSpk(nLineNo, SpkListenChannel(CheckLeftSpkListen.IsChecked, CheckRightSpkListen.IsChecked))
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bListenRightSpk = CheckRightSpkListen.IsChecked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckAllowListenConf_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.ConfAllowLine(nLineNo, CheckAllowListenConf.IsChecked, CheckAllowSpeakConf.IsChecked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bAllowListenConf = CheckAllowListenConf.IsChecked

    End Sub

    Private Sub CheckAllowSpeakConf_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)


        Dim nLineNo As Integer = ListBoxLines.SelectedIndex

        Dim bResult As Boolean = m_objVaxUserAgent.ConfAllowLine(nLineNo, CheckAllowListenConf.IsChecked, CheckAllowSpeakConf.IsChecked)
        If Not bResult Then Return

        m_aLineVoice(nLineNo).m_bAllowSpeakConf = CheckAllowSpeakConf.IsChecked

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub CheckSpkMute_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        m_objVaxUserAgent.MuteSpk(CheckSpkMute.IsChecked.Value)
    End Sub

    Private Sub CheckMuteMic_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        m_objVaxUserAgent.MuteMic(CheckMuteMic.IsChecked.Value)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub SliderSpkVol_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.RoutedPropertyChangedEventArgs(Of System.Double))

        ' Value range 0 --- (100)
        m_objVaxUserAgent.SetVolumeSpk(SliderSpkVol.Value)

    End Sub

    Private Sub SliderMicVol_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.RoutedPropertyChangedEventArgs(Of System.Double))

        ' Value range (-10) --- 0 --- (+10)
        m_objVaxUserAgent.SetVolumeMic(SliderMicVol.Value - 10)

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Function SpkListenChannel(ByVal bListenLeft As Boolean, ByVal bListenRight As Boolean) As Integer

        If bListenLeft = True AndAlso bListenRight = False Then
            Return 0
        End If

        If bListenLeft = False AndAlso bListenRight = True Then
            Return 1
        End If

        Return 2

    End Function

    Private Sub ListBoxLines_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)

        Dim nLineNo As Integer = ListBoxLines.SelectedIndex
        If nLineNo = -1 Then Return

        CheckMuteLineMIC.IsChecked = m_aLineVoice(nLineNo).m_bMuteLineMIC
        CheckMuteLineSPK.IsChecked = m_aLineVoice(nLineNo).m_bMuteLineSPK

        CheckAllowListenConf.IsChecked = m_aLineVoice(nLineNo).m_bAllowListenConf
        CheckAllowSpeakConf.IsChecked = m_aLineVoice(nLineNo).m_bAllowSpeakConf

        CheckLeftSpkListen.IsChecked = m_aLineVoice(nLineNo).m_bListenLeftSpk
        CheckRightSpkListen.IsChecked = m_aLineVoice(nLineNo).m_bListenRightSpk

        UpdateBtnStatus()

    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnAudioDeviceMicVU(ByVal nLevelVU As Integer)
        MicProgBar.Value = nLevelVU
    End Sub

    Public Sub OnAudioDeviceSpkVU(ByVal nLevelVU As Integer)
        SpkProgBar.Value = nLevelVU
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

End Class

Public Class cLineVoice

    Public m_bMuteLineMIC As Boolean = False
    Public m_bMuteLineSPK As Boolean = False
    Public m_bAllowListenConf As Boolean = True
    Public m_bAllowSpeakConf As Boolean = True
    Public m_bListenLeftSpk As Boolean = True
    Public m_bListenRightSpk As Boolean = True

End Class