﻿
Public Class SettingForm

    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM = Nothing
    Private Shared m_objSettingForm As SettingForm = Nothing

    Public Sub New()

        m_objSettingForm = Me

        InitializeComponent()
        m_objVaxUserAgent = cVaxSIPUserAgentExCOM.GetOBJ()

        CheckEchoCancel.IsChecked = True

        CheckG711U.IsChecked = True
        CheckG711A.IsChecked = True

        CheckG729.IsChecked = True
        CheckGSM610.IsChecked = True
        CheckiLBC.IsChecked = True

        RadioForceNone.IsChecked = True

        UpdateAudioIn()
        UpdateAudioOut()

        UpdateVideoDevices()
        UpdateListVideoQuality()

    End Sub

    Public Shared Function GetOBJ() As SettingForm
        Return m_objSettingForm
    End Function

    Public Sub OnVaxOnline()

        ActivateVideoDevice()

        ActivateAudioCodecs()
        ActivateVideoCodecs()

        ActivateVideoQuality()
        ActivateOtherSettings()

        ActivateDigitDTMF()

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub UpdateAudioIn()

        Dim sDeviceName As String
        Dim nDeviceId As Integer

        ListAudioIn.Items.Clear()
        ListAudioIn.Items.Add(New cMediaDevice(-1, "Default Device"))

        For nDeviceId = 0 To m_objVaxUserAgent.GetAudioInDevTotal() - 1
            sDeviceName = m_objVaxUserAgent.GetAudioInDevName(nDeviceId)
            ListAudioIn.Items.Add(New cMediaDevice(nDeviceId, sDeviceName))
        Next

        ListAudioIn.Tag = True

        ListAudioIn.SelectedIndex = 0
        Dim objAudioDevice As cMediaDevice = CType(ListAudioIn.Items(0), cMediaDevice)
        nDeviceId = objAudioDevice.m_nDeviceId
        m_objVaxUserAgent.SetActiveAudioInDevice(nDeviceId)

    End Sub

    Private Sub UpdateAudioOut()

        Dim nDeviceId As Integer
        Dim sDeviceName As String
        ListAudioOut.Items.Clear()
        ListAudioOut.Items.Add(New cMediaDevice(-1, "Default Device"))

        For nDeviceId = 0 To m_objVaxUserAgent.GetAudioOutDevTotal() - 1
            sDeviceName = m_objVaxUserAgent.GetAudioOutDevName(nDeviceId)
            ListAudioOut.Items.Add(New cMediaDevice(nDeviceId, sDeviceName))
        Next

        ListAudioOut.Tag = True

        ListAudioOut.SelectedIndex = 0
        Dim objAudioDevice As cMediaDevice = CType(ListAudioOut.Items(0), cMediaDevice)
        nDeviceId = objAudioDevice.m_nDeviceId
        m_objVaxUserAgent.SetActiveAudioOutDevice(nDeviceId)

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub UpdateVideoDevices()

        ListVideoDevices.Items.Clear()

        For nDeviceIndex As Integer = 0 To m_objVaxUserAgent.GetVideoDevTotal() - 1
            Dim sDeviceName As String = m_objVaxUserAgent.GetVideoDevName(nDeviceIndex)
            ListVideoDevices.Items.Add(New cMediaDevice(nDeviceIndex, sDeviceName))
        Next

        ListVideoDevices.Tag = True

        If ListVideoDevices.Items.Count > 0 Then ListVideoDevices.SelectedIndex = 0

    End Sub

    Private Sub UpdateListVideoQuality()

        ComboBoxVideoQuality.Items.Add("Low")
        ComboBoxVideoQuality.Items.Add("Standard")
        ComboBoxVideoQuality.Items.Add("Medium")
        ComboBoxVideoQuality.Items.Add("High")
        ComboBoxVideoQuality.Items.Add("Max")

        ComboBoxVideoQuality.Tag = True

        ComboBoxVideoQuality.SelectedIndex = 2

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub ActivateAudioCodecs()

        m_objVaxUserAgent.DeselectAllAudioCodec()

        If CheckG711U.IsChecked.Value Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711U)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711U)
        End If

        If CheckGSM610.IsChecked.Value Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_GSM610)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_GSM610)
        End If

        If CheckG711A.IsChecked.Value Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711A)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G711A)
        End If

        If CheckG729.IsChecked.Value Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G729)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_G729)
        End If

        If CheckiLBC.IsChecked.Value Then
            m_objVaxUserAgent.SelectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_ILBC)
        Else
            m_objVaxUserAgent.DeselectAudioCodec(cVaxSIPUserAgentCOM.VAX_AUDIO_CODEC_ILBC)
        End If
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateVideoCodecs()
        m_objVaxUserAgent.DeselectAllVideoCodec()
        m_objVaxUserAgent.SelectVideoCodec(cVaxSIPUserAgentCOM.VAX_VIDEO_CODEC_VP8)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateVideoQuality()
        m_objVaxUserAgent.SetVideoQuality(ComboBoxVideoQuality.SelectedIndex)
    End Sub

    Private Sub ActivateVideoDevice()
        m_objVaxUserAgent.SetActiveVideoDevice(ListVideoDevices.SelectedIndex)
    End Sub

    Private Sub ActivateOtherSettings()

        m_objVaxUserAgent.EchoCancellation(CheckEchoCancel.IsChecked.Value)
        m_objVaxUserAgent.AutoGainMic(CheckAGC.IsChecked.Value, 8000)
        m_objVaxUserAgent.SetVolumeBoostMic(CheckMicBoost.IsChecked.Value)

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '////////////////////////////////////////////////////////////////////////

    Private Sub ActivateDigitDTMF()

        If RadioForceNone.IsChecked = True Then
            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_AUTO)
        ElseIf RadioForceInbandDTMF.IsChecked = True Then
            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_INBAND)
        ElseIf RadioForceRfc2833DTMF.IsChecked = True Then
            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_RFC2833)
        ElseIf RadioForceInfoDTMF.IsChecked = True Then
            m_objVaxUserAgent.ForceDigitDTMF(cVaxSIPUserAgentCOM.VAX_DTMF_TYPE_SIP_INFO)
        End If

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub ListAudioIn_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)

        Dim objListBox As ListBox = CType(sender, ListBox)

        If objListBox.Tag IsNot Nothing Then
            objListBox.Tag = Nothing
            Return
        End If

        Dim objAudioDevice As cMediaDevice = CType(ListAudioIn.Items(ListAudioIn.SelectedIndex), cMediaDevice)
        m_objVaxUserAgent.SetActiveAudioInDevice(objAudioDevice.m_nDeviceId)

    End Sub

    Private Sub ListAudioOut_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)

        Dim objListBox As ListBox = CType(sender, ListBox)

        If objListBox.Tag IsNot Nothing Then
            objListBox.Tag = Nothing
            Return
        End If

        Dim objAudioDevice As cMediaDevice = CType(ListAudioOut.Items(ListAudioOut.SelectedIndex), cMediaDevice)
        m_objVaxUserAgent.SetActiveAudioOutDevice(objAudioDevice.m_nDeviceId)

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub CheckGSM610_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckiLBC_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckG729_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckG711A_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateAudioCodecs()
    End Sub

    Private Sub CheckG711U_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateAudioCodecs()
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub ListVideoDevices_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)

        Dim objListBox As ListBox = CType(sender, ListBox)

        If objListBox.Tag IsNot Nothing Then
            objListBox.Tag = Nothing
            Return
        End If

        ActivateVideoDevice()

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub ComboBoxVideoQuality_SelectionChanged(ByVal sender As System.Object, ByVal e As System.Windows.Controls.SelectionChangedEventArgs)

        Dim objComboBox As ComboBox = CType(sender, ComboBox)

        If objComboBox.Tag IsNot Nothing Then
            objComboBox.Tag = Nothing
            Return
        End If

        ActivateVideoQuality()

    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub CheckEchoCancel_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateOtherSettings()
    End Sub

    Private Sub CheckAGC_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateOtherSettings()
    End Sub

    Private Sub CheckMicBoost_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateOtherSettings()
    End Sub

    '/////////////////////////////////////////////////////////////////////////
    '/////////////////////////////////////////////////////////////////////////

    Private Sub RadioForceNone_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateDigitDTMF()
    End Sub

    Private Sub RadioForceInbandDTMF_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateDigitDTMF()
    End Sub

    Private Sub RadioForceRfc2833DTMF_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateDigitDTMF()
    End Sub

    Private Sub RadioForceInfoDTMF_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateDigitDTMF()
    End Sub
End Class

Public Class cMediaDevice
    Public m_nDeviceId As Integer
    Public m_sDeviceName As String

    Public Sub New(ByVal nDeviceId As Integer, ByVal sDeviceName As String)
        m_nDeviceId = nDeviceId
        m_sDeviceName = sDeviceName
    End Sub

    Public Overrides Function ToString() As String
        Return m_sDeviceName
    End Function
End Class

Public Class cDataQoS
    Public m_nQoSId As Integer
    Public m_sQoSName As String

    Public Sub New(ByVal nQoSId As Integer, ByVal sQoSName As String)
        m_nQoSId = nQoSId
        m_sQoSName = sQoSName
    End Sub

    Public Overrides Function ToString() As String
        Return m_sQoSName
    End Function
End Class
