﻿Imports System
Imports System.Collections

Class cStoreChat

    Const CHAT_ROOT_PATH As String = "Chat\"

    Public Shared Function AddContact(ByVal sContactName As String) As Boolean

        If sContactName.Length = 0 Then
            Return False
        End If

        Dim sKeyPath As String = CHAT_ROOT_PATH & sContactName
        Dim objStore As cStoreRegistry = New cStoreRegistry()

        Dim bResult As Boolean = objStore.SetTEXT(sKeyPath, "ContactName", sContactName)
        objStore.Close()

        Return bResult

    End Function

    Public Shared Sub RemoveContact(ByVal sContactName As String)

        If sContactName.Length = 0 Then
            Return
        End If

        Dim sKeyPath As String = CHAT_ROOT_PATH & sContactName
        Dim objStore As cStoreRegistry = New cStoreRegistry()

        objStore.DeleteSubKey(sKeyPath)
        objStore.Close()

    End Sub

    Public Shared Sub GetContactAll(ByRef objList As ArrayList)

        objList.Clear()

        Dim sKeyPath As String = CHAT_ROOT_PATH
        Dim objStore As cStoreRegistry = New cStoreRegistry()

        objStore.EnumSubKeys(sKeyPath, objList)
        objStore.Close()

    End Sub

    Public Shared Function AddMsg(ByVal sContactName As String, ByVal sMsgText As String) As Boolean

        If sContactName.Length = 0 Then
            Return False
        End If

        Dim sKeyPath As String = CHAT_ROOT_PATH & sContactName & "\Messages"
        Dim objStore As cStoreRegistry = New cStoreRegistry()

        Dim nMsgCount As Integer = 0

        objStore.GetINT(sKeyPath, "MsgCount", nMsgCount, 0)
        objStore.SetINT(sKeyPath, "MsgCount", nMsgCount + 1)

        objStore.SetTEXT(sKeyPath & "\MsgText", "Msg" & Convert.ToString(nMsgCount), sMsgText)
        objStore.Close()

        Return True

    End Function

    Public Shared Sub RemoveMsgAll(ByVal sContactName As String)

        If sContactName.Length = 0 Then
            Return
        End If

        Dim sKeyPath As String = CHAT_ROOT_PATH & sContactName & "\Messages"
        Dim objStore As cStoreRegistry = New cStoreRegistry()

        objStore.DeleteSubKey(sKeyPath)
        objStore.Close()

    End Sub

    Public Shared Sub GetMsgAll(ByVal sContactName As String, ByRef objList As ArrayList)

        objList.Clear()

        Dim sKeyPath As String = CHAT_ROOT_PATH & sContactName & "\Messages\MsgText"
        Dim objStore As cStoreRegistry = New cStoreRegistry()

        Dim objValueNameList As ArrayList = New ArrayList()
        objStore.EnumValueNames(sKeyPath, objValueNameList)

        For nCount As Integer = 0 To objValueNameList.Count - 1
            Dim sMsgText As String = ""
            objStore.GetTEXT(sKeyPath, CStr(objValueNameList(nCount)), sMsgText, "")
            objList.Add(sMsgText)
        Next

        objStore.Close()

    End Sub

    Public Shared Function IsDataStored() As Boolean

        Dim objStore As cStoreRegistry = New cStoreRegistry()
        Dim bResult As Boolean = objStore.IsKeyExist(CHAT_ROOT_PATH)

        objStore.Close()
        Return bResult

    End Function

End Class
