﻿Public Class VideoForm

    Private m_objVaxUserAgent As cVaxSIPUserAgentExCOM = Nothing
    Private Shared m_objVideoForm As VideoForm = Nothing

    Public Sub New()

        m_objVaxUserAgent = cVaxSIPUserAgentExCOM.GetOBJ()
        m_objVideoForm = Me

        InitializeComponent()
        CheckBoxActivate.IsChecked = True

    End Sub

    Public Shared Function GetOBJ() As VideoForm
        Return m_objVideoForm
    End Function

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVaxOnline()
        ActivateVideoPreview()
    End Sub

    Public Sub OnVaxOffline()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////////////////

    Private Sub ActivateVideoPreview()

        If CheckBoxActivate.IsChecked = True Then
            m_objVaxUserAgent.ActivateVideoDevice(True)
        Else
            m_objVaxUserAgent.CloseVideoDev()
        End If

    End Sub

    Private Sub CheckBoxActivate_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs)
        ActivateVideoPreview()
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVideoRemoteStarted(ByVal nLineNo As Integer)
    End Sub

    Public Sub OnVideoRemoteEnded(ByVal nLineNo As Integer)
    End Sub

    '////////////////////////////////////////////////////////////////////////////////////////////////
    '///////////////////////////////////////////////////////////////////////////////////////////////

    Public Sub OnVideoRemoteFrameRGB(ByVal nLineNo As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)

        If nLineNo = 0 Then DisplayFrame(VideoScreen1, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
        If nLineNo = 1 Then DisplayFrame(VideoScreen2, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
        If nLineNo = 2 Then DisplayFrame(VideoScreen3, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
        If nLineNo = 3 Then DisplayFrame(VideoScreen4, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
        If nLineNo = 4 Then DisplayFrame(VideoScreen5, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)

    End Sub

    Public Sub OnVideoDeviceFrameRGB(ByVal nDeviceId As Integer, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)
        DisplayFrame(VideoScreenPreview, aFrameRGB, nFrameSize, nFrameWidth, nFrameHeight)
    End Sub

    Public Sub DisplayFrame(ByRef ctrlGroupBoxVideo As GroupBox, ByVal aFrameRGB As Byte(), ByVal nFrameSize As Integer, ByVal nFrameWidth As Integer, ByVal nFrameHeight As Integer)

        Dim nWidth As Integer = nFrameWidth
        Dim nHeight As Integer = nFrameHeight

        Dim PixelF As PixelFormat = PixelFormats.Bgr32
        Dim rawStride As Integer = (nWidth * (PixelF.BitsPerPixel / 8))

        Dim BitmapSrc As BitmapSource = BitmapSource.Create(nWidth, nHeight, 96, 96, PixelF, Nothing, aFrameRGB, rawStride)

        Dim cImage As System.Windows.Controls.Image = New System.Windows.Controls.Image()

        cImage.Stretch = Stretch.Uniform

        cImage.Width = nWidth
        cImage.Source = BitmapSrc

        ctrlGroupBoxVideo.Content = cImage

    End Sub

End Class
